<!--
“Copyright 2020 L'esfera”

This file is part of L'esfera.

L'esfera is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
-->

<template>
    <div>        
        <vue-typeahead-bootstrap
            ref="selectInput"
            class="mb-4"
            placeholder="Afegir una nova relació"
            v-model="search_text"
            @input="lookup_link"
            :data="names"
            >
            <template slot="append">
                <b-button
                    variant="primary"
                    :disabled="disabledSubmit"
                    @click="link_selected">
                    Afegir
                </b-button>
            </template>
        </vue-typeahead-bootstrap>
    </div>
</template>


<script>
import axios from 'axios';
import VueTypeaheadBootstrap from 'vue-typeahead-bootstrap';
import {debounce} from 'lodash';
import { eventBus } from '../../../main.js'
export default {
    name: 'LinkSearch',
    components: {
        VueTypeaheadBootstrap
    },
    props: { existingLinks: Array },
    data() {
      return {
        search_text: '',
        selectedlink: null,
        links: {},
        names: [],
      }
    },
    watch: {
        links: function () {
            this.names = Object.keys(this.links)
        },
    },
    computed: {
        disabledSubmit: function () {
            return this.search_text.length < 3;
        },
    },
    methods: {
        
        lookup_link: debounce(function () {
          // in practice this action should be debounced
          // fetch(`https://api.github.com/search/users?q=${this.search_text}`)
          axios
            .get(process.env.VUE_APP_API_SERVER + '/nodes')
            .then(response => ( this.links = response.data ))
        }, 500),
        
        link_selected: function () {
            var node_name = this.search_text
            this.search_text = ""
            
            if (this.names.includes(node_name)) {
                var right_node_id = this.links[node_name]
                this.$emit("addLink", right_node_id)
            } else {
                eventBus.$emit("createNode", node_name)
            }
        },
    }
    
}

</script>

<style scoped>
span.link {
  color: #337ab7;
  cursor: pointer;
  text-decoration: underline;
}
</style>
